package com.company;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.Timestamp;
import java.util.ArrayList;

public class Server {
    private ServerSocket socket;
    private boolean interrupt;
    private ArrayList<Client> clients;

    public Server() throws IOException {
        socket = new ServerSocket(8080);
        interrupt = false;
        clients = new ArrayList<>();
    }

    public void Run() {
        while (!interrupt) {
            try {
                Socket clientSocket = socket.accept();
                System.out.println(new Timestamp(System.currentTimeMillis()) + " Client connected: " + clientSocket.getInetAddress().getHostAddress());
                Client client = new Client(clientSocket);
                // Добавление клиента в список всех подключенных клиентов
                clients.add(client);
                // Старт работы потока с подключенным клиентом
                client.start();
            } catch (IOException exception) {
                System.out.println(exception.getMessage());
            }
        }

        for (Client cl: clients) {
            cl.interrupt();

            try {
                cl.join();
            } catch (InterruptedException exception) {
                System.out.println(exception.getMessage());
            }
        }
    }

    public boolean isInterrupt() {
        return interrupt;
    }

    public void Interrupt(boolean interrupt) {
        this.interrupt = interrupt;
    }
}
